VERSION 5.00
Begin VB.Form FrmColAdj 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Color Adjustment"
   ClientHeight    =   1485
   ClientLeft      =   1980
   ClientTop       =   1575
   ClientWidth     =   3720
   Icon            =   "FrmColAdj.frx":0000
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   NegotiateMenus  =   0   'False
   ScaleHeight     =   99
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   248
   ShowInTaskbar   =   0   'False
   Begin VB.VScrollBar VsbBlue 
      Height          =   195
      LargeChange     =   5
      Left            =   1440
      Max             =   -255
      Min             =   255
      SmallChange     =   5
      TabIndex        =   6
      TabStop         =   0   'False
      Top             =   1140
      Width           =   240
   End
   Begin VB.VScrollBar VsbGreen 
      Height          =   195
      LargeChange     =   5
      Left            =   1440
      Max             =   -255
      Min             =   255
      SmallChange     =   5
      TabIndex        =   5
      TabStop         =   0   'False
      Top             =   840
      Width           =   240
   End
   Begin VB.VScrollBar VsbRed 
      Height          =   195
      LargeChange     =   5
      Left            =   1440
      Max             =   -255
      Min             =   255
      SmallChange     =   5
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   540
      Width           =   240
   End
   Begin VB.VScrollBar VsbBrightness 
      Height          =   195
      LargeChange     =   5
      Left            =   1440
      Max             =   -255
      Min             =   255
      SmallChange     =   5
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   150
      Width           =   240
   End
   Begin VB.PictureBox PicShade 
      Appearance      =   0  'Flat
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      ForeColor       =   &H00000000&
      Height          =   480
      Left            =   2010
      LinkTimeout     =   32
      ScaleHeight     =   32
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   32
      TabIndex        =   8
      TabStop         =   0   'False
      Top             =   285
      Width           =   480
   End
   Begin VB.CommandButton CmdCancel 
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   2790
      TabIndex        =   1
      Top             =   570
      Width           =   810
   End
   Begin VB.CommandButton CmdOk 
      Caption         =   "&Ok"
      Height          =   375
      Left            =   2790
      TabIndex        =   0
      Top             =   990
      Width           =   810
   End
   Begin VB.CommandButton CmdReset 
      Caption         =   "&Reset"
      Height          =   375
      Left            =   2790
      TabIndex        =   2
      Top             =   120
      Width           =   810
   End
   Begin VB.Label LblBlue 
      BackColor       =   &H80000005&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "0"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   1020
      LinkTimeout     =   0
      TabIndex        =   11
      Top             =   1110
      Width           =   690
   End
   Begin VB.Label LblGreen 
      BackColor       =   &H80000005&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "0"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   1020
      LinkTimeout     =   0
      TabIndex        =   10
      Top             =   810
      Width           =   690
   End
   Begin VB.Label LblRed 
      BackColor       =   &H80000005&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "0"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   1020
      LinkTimeout     =   0
      TabIndex        =   9
      Top             =   510
      Width           =   690
   End
   Begin VB.Label LblBrightness 
      BackColor       =   &H80000005&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "0"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   1020
      LinkTimeout     =   0
      TabIndex        =   7
      Top             =   120
      Width           =   690
   End
End
Attribute VB_Name = "FrmColAdj"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private C&, Bc&
Private W%, H%
Private NewVal%
Private CurNoBright%
Private PrevNoBright%
Private CurNoRed%
Private PrevNoRed%
Private CurNoGreen%
Private PrevNoGreen%
Private CurNoBlue%
Private PrevNoBlue%
Private Sub Form_Load()

    Icon = FrmMicroArt.Icon

    Width = 3810
    Height = 1860
    PositionForm Me

    bAdjustColors = False

End Sub
Private Sub CmdCancel_Click()

    bAdjustColors = False
    Unload Me

End Sub
Private Sub CmdOk_Click()

    bAdjustColors = True
    Unload Me

End Sub
Private Sub CmdReset_Click()

    Dim Dc&, K%

    Dc = PicShade.hDC
    Bc = GetPixel(Me.hDC, 0, 0)

    For H = 0 To MaxExtent
        For W = 0 To MaxExtent
            With Defaults(K)
                 EditVals(K).icRed = .icRed
                 EditVals(K).icGreen = .icGreen
                 EditVals(K).icBlue = .icBlue
                 OutputVals(K).icRed = .icRed
                 OutputVals(K).icGreen = .icGreen
                 OutputVals(K).icBlue = .icBlue
                 C = RGB(.icRed, .icGreen, .icBlue)
                 If .icRed = 1000 Then
                     SetPixelV Dc, W, H, Bc
                 Else
                     SetPixelV Dc, W, H, C
                 End If
            End With
            K = K + 1
        Next
    Next

    CurNoBright = 0
    PrevNoBright = 0
    CurNoRed = 0
    PrevNoRed = 0
    CurNoGreen = 0
    PrevNoGreen = 0
    CurNoBlue = 0
    PrevNoBlue = 0

    VsbBrightness.Value = 0
    VsbRed.Value = 0
    VsbGreen.Value = 0
    VsbBlue.Value = 0

End Sub
Private Sub VsbBrightness_Change()

    Dim Dc&, K%

    Dc = PicShade.hDC

    LblBrightness.Caption = VsbBrightness.Value
    CurNoBright = VsbBrightness.Value
    If CurNoBright = PrevNoBright Then Exit Sub
    If CurNoBright > PrevNoBright Then NewVal = 5 Else NewVal = -5

    For H = 0 To MaxExtent
        For W = 0 To MaxExtent
            With EditVals(K)
                .icRed = .icRed + NewVal
                 If .icRed > -1 And .icRed < 256 Then OutputVals(K).icRed = .icRed
                .icGreen = .icGreen + NewVal
                 If .icGreen > -1 And .icGreen < 256 Then OutputVals(K).icGreen = .icGreen
                .icBlue = .icBlue + NewVal
                 If .icBlue > -1 And .icBlue < 256 Then OutputVals(K).icBlue = .icBlue
            End With
            With OutputVals(K)
                 If .icRed <> 1000 Then
                     C = RGB(.icRed, .icGreen, .icBlue)
                     SetPixelV Dc, W, H, C
                 End If
            End With
            K = K + 1
        Next
    Next

    PrevNoBright = CurNoBright

End Sub
Private Sub VsbRed_Change()

    Dim Dc&, K%

    Dc = PicShade.hDC

    LblRed.Caption = VsbRed.Value
    CurNoRed = VsbRed.Value
    If CurNoRed = PrevNoRed Then Exit Sub
    If CurNoRed > PrevNoRed Then NewVal = 5 Else NewVal = -5

    For H = 0 To MaxExtent
        For W = 0 To MaxExtent
            With EditVals(K)
                .icRed = .icRed + NewVal
                 If .icRed > -1 And .icRed < 256 Then OutputVals(K).icRed = .icRed
            End With
            With OutputVals(K)
                 C = RGB(.icRed, .icGreen, .icBlue)
                 If .icRed <> 1000 Then SetPixelV Dc, W, H, C
            End With
            K = K + 1
        Next
    Next

    PrevNoRed = CurNoRed

End Sub
Private Sub VsbGreen_Change()

    Dim Dc&, K%

    Dc = PicShade.hDC

    LblGreen.Caption = VsbGreen.Value
    CurNoGreen = VsbGreen.Value
    If CurNoGreen = PrevNoGreen Then Exit Sub
    If CurNoGreen > PrevNoGreen Then NewVal = 5 Else NewVal = -5

    For H = 0 To MaxExtent
        For W = 0 To MaxExtent
            With EditVals(K)
                .icGreen = .icGreen + NewVal
                 If .icGreen > -1 And .icGreen < 256 Then OutputVals(K).icGreen = .icGreen
            End With
            With OutputVals(K)
                 C = RGB(.icRed, .icGreen, .icBlue)
                 If .icGreen <> 1000 Then SetPixelV Dc, W, H, C
            End With
            K = K + 1
        Next
    Next

    PrevNoGreen = CurNoGreen

End Sub
Private Sub VsbBlue_Change()

    Dim Dc&, K%

    Dc = PicShade.hDC

    LblBlue.Caption = VsbBlue.Value
    CurNoBlue = VsbBlue.Value
    If CurNoBlue = PrevNoBlue Then Exit Sub
    If CurNoBlue > PrevNoBlue Then NewVal = 5 Else NewVal = -5

    For H = 0 To MaxExtent
        For W = 0 To MaxExtent
            With EditVals(K)
                .icBlue = .icBlue + NewVal
                 If .icBlue > -1 And .icBlue < 256 Then OutputVals(K).icBlue = .icBlue
            End With
            With OutputVals(K)
                 C = RGB(.icRed, .icGreen, .icBlue)
                 If .icBlue <> 1000 Then SetPixelV Dc, W, H, C
            End With
            K = K + 1
        Next
    Next

    PrevNoBlue = CurNoBlue

End Sub
Private Sub Form_Paint()

    Dim Rct As RECT

    With PicShade
         SetRect Rct, 123, 8, 123 + 48 + 6, 8 + 48 + 6
    End With

    DrawEdge hDC, Rct, &H2, &HF

    CurrentX = 8
    CurrentY = 10
    Print "Brightness:"

    CurrentX = 8
    CurrentY = 36
    Print "Red:"

    CurrentX = 8
    CurrentY = 56
    Print "Green:"

    CurrentX = 8
    CurrentY = 76
    Print "Blue:"

End Sub
