VERSION 5.00
Begin VB.Form FrmIcons 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   3660
   ClientLeft      =   2175
   ClientTop       =   1815
   ClientWidth     =   6255
   Icon            =   "FrmIcons.frx":0000
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   NegotiateMenus  =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   244
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   417
   ShowInTaskbar   =   0   'False
   Begin VB.PictureBox PicFrame 
      BackColor       =   &H00FFFFFF&
      ForeColor       =   &H00000000&
      Height          =   2910
      Left            =   120
      LinkTimeout     =   0
      ScaleHeight     =   190
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   397
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   120
      Width           =   6015
      Begin VB.VScrollBar Vsb 
         Height          =   2850
         LargeChange     =   38
         Left            =   5700
         TabIndex        =   0
         Top             =   0
         Width           =   255
      End
      Begin VB.PictureBox PicIcons 
         Appearance      =   0  'Flat
         AutoRedraw      =   -1  'True
         BackColor       =   &H00FFFFFF&
         BorderStyle     =   0  'None
         DrawWidth       =   2
         ForeColor       =   &H000000FF&
         Height          =   2850
         Left            =   0
         LinkTimeout     =   0
         ScaleHeight     =   190
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   380
         TabIndex        =   5
         TabStop         =   0   'False
         Top             =   0
         Width           =   5700
      End
   End
   Begin VB.CommandButton CmdCancel 
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   3120
      TabIndex        =   3
      Top             =   3165
      Width           =   975
   End
   Begin VB.CommandButton CmdOk 
      Caption         =   "&Ok"
      Height          =   375
      Left            =   4140
      TabIndex        =   2
      Top             =   3165
      Width           =   975
   End
   Begin VB.CommandButton CmdBrowse 
      Caption         =   "&Browse"
      Height          =   375
      Left            =   5160
      TabIndex        =   1
      Top             =   3165
      Width           =   975
   End
   Begin VB.Label LblInfo 
      Appearance      =   0  'Flat
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Icon No 1 Selected."
      ForeColor       =   &H80000008&
      Height          =   195
      Left            =   120
      TabIndex        =   6
      Top             =   3375
      Width           =   1425
   End
End
Attribute VB_Name = "FrmIcons"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private bAni As Boolean
Private bProcessing As Boolean
Private CurFile$
Private CurName$
Private IconCount%
Private NewIdx%
Private nLeft%
Private nTop%
Private Sub Form_Load()

    bAni = False

    CurFile = Shell32Path
    CurName = "Shell32.dll"
    IconCount = ExtractIconEx(CurFile, -1, 0, 0, 0)
    UpdateCaption
    DrawIcons

    Icon = FrmMicroArt.Icon
    Width = 6345
    Height = 4035
    PositionForm Me

    nLeft = 1
    nTop = 1
    bCancelled = True

End Sub
Private Sub CmdBrowse_Click()

    Dim Msg$
    Dim RetVals As FILEINFO

    RetVals = GetFileName(hWnd, 5)
    If Not RetVals.bSuccess Then Exit Sub

    CurFile = RetVals.fiFileName
    CurName = RetVals.fiFileTitle

    bProcessing = True

    If FileHasIcons Then
       UpdateCaption
       LblInfo.Caption = "Icon No 1 Selected."
       PicIcons.Cls
       PicIcons.Picture = LoadPicture()
       DoEvents
       DrawIcons
    Else
       Msg = CurName & " contains no icons."
       MsgBox Msg, vbInformation, "MicroArt"
    End If

    bProcessing = False

End Sub
Private Function FileHasIcons() As Boolean

    If LCase(Right(CurFile, 4)) = ".ani" Then
       bAni = True
       GetFrameCount
    Else
       bAni = False
       IconCount = ExtractIconEx(CurFile, -1, 0, 0, 0)
    End If

    If IconCount = 0 Then
       FileHasIcons = False
    Else
       FileHasIcons = True
    End If

End Function
Private Sub GetFrameCount()

    Dim hIcon&, K%, Rv&

    ExtractIconEx CurFile, 0, hIcon, 0, 1
    For K = 0 To 32767
        Rv = DrawIconEx(hDC, 50, 50, hIcon, 32, 32, K, 0, &H3)
        If Rv = 0 Then Exit For
    Next
    DestroyIcon hIcon

    IconCount = K

End Sub
Private Sub DrawIcons()

    Dim hIcon&, Idx%, H%, W%, Ub%
    Dim intIcoRows%, sngIcoRows!

    sngIcoRows = IconCount / 10
    intIcoRows = IconCount \ 10
    If sngIcoRows > intIcoRows Then
       intIcoRows = intIcoRows + 1
    End If
    If intIcoRows > 5 Then
       PicIcons.Height = intIcoRows * 38
       Vsb.Enabled = 1
       Vsb.Max = intIcoRows * 38 - 190
    Else
       PicIcons.Height = 190
       Vsb.Enabled = 0
    End If

    H = 3
    W = 3
    Ub = IconCount - 1

    PicIcons.Move 0, 0
    Vsb.Value = 0
    DoEvents

    If bAni Then
       ExtractIconEx CurFile, 0, hIcon, 0, 1
       For Idx = 0 To Ub
           DrawIconEx PicIcons.hDC, W, H, hIcon, 32, 32, Idx, 0, &H3
           W = W + 38
           If (Idx + 1) Mod 10 = 0 Then
              W = 3
              H = H + 38
           End If
       Next
       DestroyIcon hIcon
    Else
       For Idx = 0 To Ub
           ExtractIconEx CurFile, Idx, hIcon, 0, 1
           DrawIconEx PicIcons.hDC, W, H, hIcon, 32, 32, 0, 0, &H3
           DestroyIcon hIcon
           W = W + 38
           If (Idx + 1) Mod 10 = 0 Then
              W = 3
              H = H + 38
           End If
       Next
    End If

    PicIcons.Picture = PicIcons.Image
    PicIcons.Refresh
    nLeft = 1
    nTop = 1
    PicIcons.Line (1, 1)-(37, 37), , B
    NewIdx = 0

End Sub
Private Sub PicIcons_MouseUp(Button%, Shift%, X!, Y!)

    Dim CurselTemp%

    If bProcessing Then Exit Sub

    If X >= 0 And X <= 390 And Y >= 0 And Y <= PicIcons.ScaleHeight Then
      CurselTemp = (X \ 38) + (Y \ 38) * 10
      If CurselTemp + 1 > IconCount Then
         Exit Sub
      Else
         NewIdx = CurselTemp
         LblInfo.Caption = "Icon No " & NewIdx + 1 & " Selected."
         PicIcons.Line (nLeft, nTop)-(nLeft + 36, nTop + 36), &HFFFFFF, B
         nLeft = ((X \ 38) * 38) + 1
         nTop = ((Y \ 38) * 38) + 1
         PicIcons.Line (nLeft, nTop)-(nLeft + 36, nTop + 36), , B
      End If
    End If

End Sub
Private Sub Vsb_Change()

    PicIcons.Top = -Vsb.Value

End Sub
Private Sub Vsb_Scroll()

    PicIcons.Top = -Vsb.Value

End Sub
Private Sub CmdCancel_Click()

    Unload Me

End Sub
Private Sub CmdOk_Click()

    bCancelled = False
    ExtractFile = CurFile
    ExtractIdx = NewIdx
    Unload Me

End Sub
Private Sub UpdateCaption()

    Caption = "MicroArt - " & CurName & " - " & IconCount & " Icons"

End Sub
