Attribute VB_Name = "ModRecent"
Option Explicit
Public Sub AddToRecent(Fn$, MRec As Object)

    Dim Temp$
    Dim K%, N%
    Dim bFound As Boolean

    MRec(0).Visible = 1

    For K = 1 To 4
        If LCase(MRec(K).Tag) = LCase(Fn) Then
           bFound = True
           Exit For
        End If
    Next

    If bFound Then
       If K > 1 Then
          Temp = MRec(K).Tag
          For N = K To 1 Step -1
              MRec(N).Tag = MRec(N - 1).Tag
          Next
          MRec(1).Tag = Temp
       End If
    Else
       For K = 4 To 1 Step -1
           MRec(K).Tag = MRec(K - 1).Tag
       Next
       MRec(1).Tag = Fn
    End If

    For K = 1 To 4
        If MRec(K).Tag <> "" Then MRec(K).Visible = 1
    Next

    BuildMenu MRec

End Sub
Public Sub UpdateRecent(MRec As Object)

    Dim K%, N
    Dim NewArray$(1 To 4)

    N = 1

    For K = 1 To 4
        If MRec(K).Tag <> "" Then
           NewArray(N) = MRec(K).Tag
           N = N + 1
           MRec(K).Tag = ""
        End If
    Next

    For K = 1 To 4
        If NewArray(K) <> "" Then
           MRec(K).Tag = NewArray(K)
        Else
           MRec(K).Visible = 0
        End If
    Next

    If MRec(1).Visible = 0 Then
       MRec(0).Visible = 0
    Else
       BuildMenu MRec
    End If

End Sub
Public Sub BuildMenu(MRec As Object)

    Dim K%

    For K = 1 To 4
        If MRec(K).Tag <> "" Then
           MRec(K).Caption = "&" & CStr(K) & " " & GetTitle(MRec(K).Tag)
        End If
    Next

End Sub
Public Function GetTitle$(FileNameIn$)

    Dim K%, L%

    L = Len(FileNameIn)

    For K = L To 1 Step -1
        If Mid(FileNameIn, K, 1) = "\" Then Exit For
    Next

    GetTitle = Mid(FileNameIn, K + 1)

End Function
