Attribute VB_Name = "ModUndoRedo"
Option Explicit

Private vItem As Variant
Private UniqueNum&

Public ColUndo As New Collection
Public ColRedo As New Collection
Public Sub DeleteCollections()

    For Each vItem In ColUndo
        ColUndo.Remove 1
    Next

    For Each vItem In ColRedo
        ColRedo.Remove 1
    Next

    UniqueNum = 0

End Sub
Public Sub UpdateUndo()

    Dim W%, H%

    On Error Resume Next

    With FrmMicroArt.PicIcon
         W = .Width
         H = .Height
    End With

    UniqueNum = UniqueNum + 1

    With FrmMicroArt.PicCol
        .Picture = LoadPicture()
         BitBlt .hDC, 0, 0, W, H, FrmMicroArt.PicMask.hDC, 0, 0, vbSrcCopy
         BitBlt .hDC, W, 0, W, H, FrmMicroArt.PicImage.hDC, 0, 0, vbSrcCopy
        .Picture = .Image
         ColUndo.Add .Picture, CStr(UniqueNum)
    End With

    If Err.Number Then Err.Clear
    On Error GoTo 0

End Sub
Public Sub DoUnDo()

    Dim W%, H%

    On Error Resume Next

    With FrmMicroArt.PicIcon
         W = .Width
         H = .Height
    End With

    ColRedo.Add ColUndo.Item(ColUndo.Count)
    ColUndo.Remove ColUndo.Count
    With FrmMicroArt
        .PicCol.Picture = ColUndo.Item(ColUndo.Count)
         BitBlt .PicMask.hDC, 0, 0, W, H, .PicCol.hDC, 0, 0, vbSrcCopy
         BitBlt .PicImage.hDC, 0, 0, W, H, .PicCol.hDC, W, 0, vbSrcCopy
        .DisplayResults
    End With

    If Err.Number Then Err.Clear
    On Error GoTo 0

End Sub
Public Sub DoReDo()

    Dim W%, H%

    On Error Resume Next

    With FrmMicroArt.PicIcon
         W = .Width
         H = .Height
    End With

    ColUndo.Add ColRedo.Item(ColRedo.Count)
    ColRedo.Remove ColRedo.Count
    With FrmMicroArt
        .PicCol.Picture = ColUndo.Item(ColUndo.Count)
         BitBlt .PicMask.hDC, 0, 0, W, H, .PicCol.hDC, 0, 0, vbSrcCopy
         BitBlt .PicImage.hDC, 0, 0, W, H, .PicCol.hDC, W, 0, vbSrcCopy
        .DisplayResults
    End With

    If Err.Number Then Err.Clear
    On Error GoTo 0

End Sub
Public Sub ClearRedo()

    For Each vItem In ColRedo
        ColRedo.Remove 1
    Next

End Sub
